Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 204951 - x11-drivers/xf86-input-evdev-1.2.0 crashes when pressing non-left mouse button
Summary: x11-drivers/xf86-input-evdev-1.2.0 crashes when pressing non-left mouse button
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: Piotr Jaroszyński (RETIRED)
URL: http://bugs.freedesktop.org/show_bug....
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-01-08 20:27 UTC by Dennis Schridde
Modified: 2009-02-02 15:40 UTC (History)
5 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Patch to fix the problem (1.2.0-fix_button_struct.patch,407 bytes, patch)
2008-02-02 18:58 UTC, Jon Wagoner
Details | Diff
Updated ebuild to use the patch (xf86-input-evdev-1.2.0-r1.ebuild,1.00 KB, text/plain)
2008-02-02 18:58 UTC, Jon Wagoner
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Dennis Schridde 2008-01-08 20:27:53 UTC
When I press a mouse button other than the left one, x11-drivers/xf86-input-evdev-1.2.0 crashes. Sadly there is no usable backtrace or error message in Xorg.0.log.
If any info is needed, just ask.

Reproducible: Always

Steps to Reproduce:
Comment 1 Dennis Schridde 2008-01-08 20:29:40 UTC
Adding Olaf Freyer from bug #200087.
Comment 2 Dennis Schridde 2008-01-08 20:30:57 UTC
PS: What seems common about us two is that we both use input.xkb.layout=de.
Comment 3 Olaf Freyer 2008-01-08 20:49:18 UTC
just in case it helps tracking down things we have in common:

aaron@localhost ~ $ emerge --info
Portage 2.1.4_rc14 (default-linux/amd64/2007.0/desktop, gcc-4.2.2, glibc-2.7-r1, 2.6.23-gentoo-r5 x86_64)
=================================================================
System uname: 2.6.23-gentoo-r5 x86_64 AMD Athlon(tm) 64 X2 Dual Core Processor 4400+
Timestamp of tree: Tue, 08 Jan 2008 17:00:08 +0000
app-shells/bash:     3.2_p33
dev-java/java-config: 1.3.7, 2.1.3
dev-lang/python:     2.5.1-r5
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 1.12.10-r5
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r1
sys-devel/automake:  1.5, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.24
virtual/os-headers:  2.6.23-r3
ACCEPT_KEYWORDS="amd64 ~amd64"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=athlon64"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/revdep-rebuild /etc/splash /etc/terminfo /etc/udev/rules.d"
CXXFLAGS="-O2 -pipe -march=athlon64"
DISTDIR="/usr/portage/distfiles"
FEATURES="distlocks metadata-transfer sandbox sfperms strict unmerge-orphans userfetch"
GENTOO_MIRRORS="http://mirror.muntinternet.net/pub/gentoo/ http://ftp.belnet.be/mirror/rsync.gentoo.org/gentoo/ http://gentoo.tiscali.nl/"
LANG="de_DE.UTF-8"
LC_ALL="de_DE.UTF-8"
LINGUAS="de"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --filter=H_**/files/digest-*"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="   "
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="16bit 3dnow 3dnowext X aac acl acpi aim alsa amd64 arts avahi bash-completion berkdb big-tables bitmap-fonts branding browserplugin cairo cdr cdrom cjk cli cpudetection cracklib crypt cups cxx dbus dhcp directfb divx dri dvd dvdr dvdread eds emboss encode esd evo exif fam fbcon fbdev fbsplash firefox flac fontconfig foomaticdb fortran gconf gdbm gif glitz glut gmedia gmp gnome gnutls gphoto2 gpm gstreamer gtk hal hddtemp iconv idn imap ipv6 isdnlog java java5 javascript jpeg jpeg2k kde kdehiddenvisibility kerberos kipi ldap libnotify lm_sensors logitech-mouse mad matroska max-idx-128 mdnsresponder-compat midi mikmod mmx mmxext mng mozdevelop mp3 mp4 mpeg mudflap musicbrainz mysql nat ncurses nforce2 nls nptl nptlonly nsplugin ntfs nvidia ogg openal opengl openmp oss pam parport pcre pdf perl png ppds pppd python qt3 qt3support qt4 quicktime readline realmedia reflection resolvconf sdl sensord session spell spl sqlite3 sse sse2 ssl svg svgz tcpd theora tiff truetype truetype-fonts type1 type1-fonts unicode urandom usb utempter vorbis wmp xattr xcomposite xml xorg xv yahoo zeroconf zip zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="evdev keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="de" USERLAND="GNU" VIDEO_CARDS="nv vesa vga fbdev"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LDFLAGS, MAKEOPTS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 4 Dennis Schridde 2008-01-08 21:52:58 UTC
Portage 2.1.4_rc14 (default-linux/amd64/2007.0/desktop, gcc-4.1.2, glibc-2.7-r1, 2.6.23-gentoo-r5 x86_64)
=================================================================
System uname: 2.6.23-gentoo-r5 x86_64 AMD Athlon(tm) 64 X2 Dual Core Processor 5000+
Timestamp of tree: Tue, 08 Jan 2008 16:46:01 +0000
app-shells/bash:     3.2_p33
dev-java/java-config: 1.3.7, 2.1.3
dev-lang/python:     2.5.1-r5
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 2.0.0_rc6-r1
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r1
sys-devel/automake:  1.5, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.24
virtual/os-headers:  2.6.23-r3
ACCEPT_KEYWORDS="amd64 ~amd64"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-pipe -O2 -march=athlon64"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/splash /etc/terminfo /etc/texmf/web2c /etc/udev/rules.d"
CXXFLAGS="-pipe -O2 -march=athlon64"
DISTDIR="/usr/portage/distfiles"
FEATURES="collision-protect distlocks metadata-transfer parallel-fetch sandbox sfperms strict unmerge-orphans userfetch userpriv usersandbox"
GENTOO_MIRRORS="ftp://ftp.tu-clausthal.de/pub/linux/gentoo/ ftp://linux.rz.ruhr-uni-bochum.de/gentoo-mirror/ ftp://ftp.mneisen.org/gentoo"
LANG="en_GB.UTF-8"
LDFLAGS="-Wl,--hash-style=gnu"
LINGUAS="de"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --delete-after --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --filter=H_**/files/digest-*"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/portage/local/layman/sunrise /usr/portage/local/layman/dirtyepic /usr/local/portage"
SYNC="rsync://rsync.europe.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext X a52 aac acl acpi alsa amd64 apache2 avahi bash-completion berkdb bitmap-fonts bluetooth cairo cdr cjk cli cracklib crypt cups dbus dri dvb dvd dvdr dvdread emboss encode evo fam ffmpeg firefox flac foomaticdb fortran gdbm gif gimp gpm gtk hal iconv ipod ipv6 isdnlog jpeg kde kdehiddenvisibility kerberos ldap lm_sensors mad midi mikmod mmx mmxext mp3 mp4 mpeg mplayer mudflap mysql ncurses nls nptl nptlonly nsplugin ogg openal openexr opengl openmp pam pch pcre pdf perl php png ppds pppd python qt3 qt3support qt4 quicktime readline reflection ruby samba sasl sdl session speex spell spl sse sse2 ssl subversion svg tcpd tetex theora threads tiff truetype truetype-fonts type1-fonts unicode usb vcd visualization vorbis x264 xcb xcomposite xinerama xml xorg xv xvid xvmc zlib" ALSA_CARDS="hda-intel" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif so speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="de" USERLAND="GNU" VIDEO_CARDS="nvidia"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 5 Olaf Freyer 2008-01-09 00:28:29 UTC
I don't know if this extra bit of information is of any use, but the mouse/keyboard combination I'm using is a Logitech Cordless Desktop MX3100. That uses a common USB reciever for both the mouse and the keyboard.
Comment 6 Olaf Freyer 2008-01-09 00:33:14 UTC
and this is what Xorg.0.log tells me when detecting the mouse/keyboard:
(Note those 96 mouse buttons? I might find about a dozen... but 96?)

(II) LoadModule: "evdev"
(II) Loading /usr/lib64/xorg/modules/input//evdev_drv.so
(II) Module evdev: vendor="X.Org Foundation"
        compiled for 1.4.0.90, module version = 1.2.0
        Module class: X.Org XInput Driver
        ABI class: X.Org XInput driver, version 2.0
(**) Logitech USB Receiver: always reports core events
(II) Logitech USB Receiver: Found 4 relative axes.
(II) Logitech USB Receiver: Configuring as pointer.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Unable to parse 'null' as a map specifier string.
(EE) Logitech USB Receiver: Button(null)MapTo: Button 96 already claimed.
(EE) Logitech USB Receiver: Unable to parse 'Button 96' as a map specifier.
(II) Logitech USB Receiver: Found 96 mouse buttons
(II) Logitech USB Receiver: Configured 96 mouse buttons.
(**) Option "xkb_model" "evdev"
(**) Option "xkb_layout" "us"
(II) XINPUT: Adding extended input device "Logitech USB Receiver" (type: KEYBOARD)
(**) Logitech USB Receiver: 2 valuators.
(**) Logitech USB Receiver: Configuring in Absolute mode.
(**) Logitech USB Receiver: Registering 96 buttons.
evdev: leds are 0x0 for device 4
(II) Logitech USB Receiver: Init
(II) Logitech USB Receiver: On
(**) Logitech USB Receiver: always reports core events
(**) Option "xkb_model" "evdev"
(**) Option "xkb_layout" "us"
(II) XINPUT: Adding extended input device "Logitech USB Receiver" (type: KEYBOARD)
evdev: leds are 0x0 for device 5
(II) Logitech USB Receiver: Init
(II) Logitech USB Receiver: On
Comment 7 Dennis Schridde 2008-01-09 00:38:58 UTC
I am using a similar Mouse/Keyboard combo with single reciever from Logitech, the LX700 (iirc).
My Xorg.0.log looks exactly the same, except that I have "xkb_layout=de" and not "us".
Comment 8 Olaf Freyer 2008-01-09 16:16:03 UTC
As I presume this to be an upstream issue I also reported this over at: https://bugs.freedesktop.org/show_bug.cgi?id=13991
Comment 9 nuitari 2008-01-16 20:10:44 UTC
I have the same issue.

I have a G15 Gaming keyboard and a MX700 mouse through the USB Receiver.

I am trying a downgrade of evdev only.
Again, no useful information in any console / log file. There is a small note about X segfaulting in dmesg.

Portage 2.1.4 (default-linux/amd64/2006.1/desktop, gcc-4.2.2, glibc-2.7-r1, 2.6.23-gentoo-r5 x86_64)
=================================================================
System uname: 2.6.23-gentoo-r5 x86_64 AMD Athlon(tm) 64 X2 Dual Core Processor 3800+
Timestamp of tree: Tue, 15 Jan 2008 15:00:01 +0000
distcc 2.18.3 x86_64-pc-linux-gnu (protocols 1 and 2) (default port 3632) [enabled]
app-shells/bash:     3.2_p33
dev-java/java-config: 1.3.7, 2.1.3
dev-lang/python:     2.5.1-r5
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 1.12.11
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r1
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.24
virtual/os-headers:  2.6.23-r3
ACCEPT_KEYWORDS="amd64 ~amd64"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=athlon64 -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/lib/fax /usr/share/config /var/bind /var/qmail/alias /var/qmail/control /var/spool/fax/etc"
CONFIG_PROTECT_MASK="/etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/terminfo /etc/texmf/web2c /etc/udev/rules.d"
CXXFLAGS="-march=athlon64 -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="ccache distcc distlocks metadata-transfer sandbox sfperms strict unmerge-orphans userfetch"
GENTOO_MIRRORS="http://distfiles.gentoo.org http://distro.ibiblio.org/pub/linux/distributions/gentoo"
LINGUAS="en fr"
MAKEOPTS="-j5"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --filter=H_**/files/digest-*"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/portage/local/layman/voip /usr/portage/local/layman/xeffects /usr/local/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="X alsa amarok amd64 apache2 berkdb bitmap-fonts bzip2 cairo cdr cli cracklib crypt cups dbus dlloader dv dvd dvdr eds emboss encode fam firefox fortran gdbm gif gpm gtk gtk2 hal iconv isdnlog jpeg kde kdeenablefinal lcd mad matroska midi mikmod mp3 mpeg mudflap ncurses nls nptl nptlonly ogg oggvorbis opengl openmp pam pcre perl png ppds pppd python qt3 qt4 quicktime readline reflection sdl session spell spl sse3 ssl ssse3 svg tcpd truetype truetype-fonts type1-fonts unicode vorbis xinerama xml xorg xv xvid zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif so speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="evdev keyboard mouse" KERNEL="linux" LCD_DEVICES="g15" LINGUAS="en fr" USERLAND="GNU" VIDEO_CARDS="nvidia v4l"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, LDFLAGS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 10 nuitari 2008-01-16 22:00:10 UTC
Downgrading evdev to 1.1.5-r2 cuases a non functionnal X w/ xorg-server 1.4.0.90
Comment 11 nuitari 2008-01-17 13:51:57 UTC
I removed the hal flag from xorg-server and downgraded to x11-drivers/xf86-input-evdev-1.1.5-r2 and my system finally works.

I did the instructions contained in 
http://forums.gentoo.org/viewtopic-t-641870-postdays-0-postorder-asc-start-25.html

which is to add the following in package.mask

>=sys-apps/hal-0.5.10
>=x11-drivers/xf86-input-evdev-1.2.0
>=app-misc/hal-info-20071011 

Recompiling all 3.
And disabling hal in xorg-server.

I just realised that I did not restart hal, so there could be something else going on.
Comment 12 Jon Wagoner 2008-01-23 05:04:33 UTC
I ran into the same problem, and tracked it down on my machine to an improperly initialized array.  I posted a patch to the freedesktop bugzilla that fixes the problem for me.
Comment 13 Dennis Schridde 2008-01-23 20:55:05 UTC
Confirming: Patch works. Thanks a lot!
Could be included in a -r1.
Comment 14 Olaf Freyer 2008-01-29 09:02:52 UTC
I can confirum the issue being resolved with this patch.
It seems like UPSTREAM accepted and applied the patch, so it seems to be fine.
Thanks alot.
Comment 15 Jon Wagoner 2008-02-02 18:58:12 UTC
Created attachment 142526 [details, diff]
Patch to fix the problem
Comment 16 Jon Wagoner 2008-02-02 18:58:47 UTC
Created attachment 142527 [details]
Updated ebuild to use the patch
Comment 17 Jon Wagoner 2008-02-02 18:59:42 UTC
Upstream has applied my patch.  I have attached the patch and an updated ebuild.  Could someone put this in portage?
Comment 18 Karol Krizka 2008-02-04 00:33:40 UTC
The patch fixed the problem on my computer. Thanks!
Comment 19 Rémi Cardona gentoo-dev 2009-02-02 15:40:44 UTC
The patch has been in newer versions of evdev for a looong time ago. Please don't hesitate to open new bugs if you have any issues with newer versions of evdev.

Thanks